﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Text.RegularExpressions;

namespace SpringfieldUniversitySimple
{
    public class University
    {
        private const char FileValuesSeparator = ',';
        private const double BestStudentsAverageLimit = 1.2;
        private const double BadStudentAverageLimit = 3;

        private readonly IList<Student> students = new List<Student>();

        public IList<Student> Students { get { return students; } }

        /*
         * Generator
         * 
         * Pomoci klicoveho slova yield lze vytvorit metodu, ktera se chova jako 
         * iterator. Kompilator sam vygeneruje prislusnou tridu pro popsany iterator.
         * 
         * yield return <vyraz>;   Oznacuje vraceni hodnoty z iteratoru a zaroven
         *                         si zapamatuje pozici v programu iteratoru, kde
         *                         skoncil. V dalsi iteraci pokracuje od tohoto
         *                         mista dale.
         *                           
         * yield break;            Slouzi pro okamzite ukonceni iterace. Na rozdil 
         *                         samotneho break se okamzite ukonci cely iterator,
         *                         ne jen prislusny cyklus.
         * 
         */

        public IEnumerable<Student> GetBestStudents()
        {
            throw new NotImplementedException();
        }

        public IEnumerable<Student> GetWorstStudents()
        {
            throw new NotImplementedException();
        }

        /*
         * LINQ
         */

        public IEnumerable<Student> StudentsWithMissingMarks()
        {
            throw new NotImplementedException();
        }

        public void PrintStudentsGroupedByLastName()
        {
            throw new NotImplementedException();
        }

        public void PrintMarksGroupedBySeminars()
        {
            throw new NotImplementedException();
        }

        /*
         * File Operations
         *
         */

        public void LoadFromFile(string filename)
        {
            throw new NotImplementedException();
        }


        public void SaveToFile(string filename)
        {
            throw new NotImplementedException();
        }

        private static string GenerateLine(Student student)
        {
            throw new NotImplementedException();
        }
    }
}
